/* GWNUM -- IBDWT FFT package for large numbers.

  Copyright 1996-2005 George Woltman.

  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the
  Free Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
  more details.

  You should have received a copy of the GNU General Public License along
  with this program; see the file COPYING.  If not, write to the Free
  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
  02111-1307, USA.
*/

/*----------------------------------------------------------------------
| gwdbldbl.h
|
| This file contains the headers for the gwnum helper routines that use
| extended-precision floats.
+---------------------------------------------------------------------*/

#ifndef _GWDBLDBL_H
#define _GWDBLDBL_H

/* This is a C library.  If used in a C++ program, don't let the C++ */
/* compiler mangle names. */

#ifdef __cplusplus
extern "C" {
#endif

/* Include common definitions */

#include "common.h"

/* Extended precision helper routines */

void gwasm_constants (double, signed long, int, int, unsigned long, unsigned long, double *);
void gwfft_weight_setup (int, double, unsigned long, signed long, unsigned long);
double gwfft_weight (unsigned long);
double gwfft_weight_sloppy (unsigned long);
double gwfft_weight_inverse (unsigned long);
double gwfft_weight_inverse_sloppy (unsigned long);
double gwfft_weight_inverse_over_fftlen (unsigned long);
void gwfft_weights3 (unsigned long, double *, double *, double *);
double gwfft_weight_exponent (unsigned long);
unsigned long gwfft_base (unsigned long);
void gwsincos (unsigned long, unsigned long, double *);
void gwsincos3 (unsigned long, unsigned long, double *);

#ifdef __cplusplus
}
#endif

#endif
