; GWNUM -- IBDWT FFT package for large numbers.
;
;  Copyright 1996-2005 George Woltman.
;
;  This program is free software; you can redistribute it and/or modify it
;  under the terms of the GNU General Public License as published by the
;  Free Software Foundation; either version 2 of the License, or (at your
;  option) any later version.
;
;  This program is distributed in the hope that it will be useful, but WITHOUT
;  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
;  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
;  more details.
;
;  You should have received a copy of the GNU General Public License along
;  with this program; see the file COPYING.  If not, write to the Free
;  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
;  02111-1307, USA.

; Author:  George Woltman
; Email: woltman@alum.mit.edu
;
; This routine implements a discrete weighted transform to quickly multiply
; two numbers.
;
; This code uses Pentium 4's SSE2 instructions for very fast FFTs.
; FFT sizes up to 8K are supported in a single pass.
;
; You will not stand a chance of understanding any of this code without
; thoroughly familiarizing yourself with fast fourier transforms.  This
; code was adapted from an algorithm described in Richard Crandall's article
; on Discrete Weighted Transforms and Large-Integer Arithmetic.
;

	TITLE   setup

IFNDEF X86_64
	.686
	.XMM
	.MODEL	FLAT
ENDIF

INCLUDE	unravel.mac
INCLUDE extrn.mac
INCLUDE xfft1.mac
INCLUDE	xlucas.mac
INCLUDE xmult.mac

;; All the FFT routines for each FFT length

_TEXT SEGMENT

_gw_xffts1 PROC
	EXPANDING = 1
	xfft	32
	xfft	48
	xfft	64
	xfft	80
	xfft	96
	xfft	112
	xfft	128
	xfft	160
	xfft	192
	xfft	224
	xfft	256
	xfft	320
	xfft	384
	xfft	448
	xfft	512
	xfft	640
	xfft	768
	xfft	896
	xfft	1024
	xfft	1280
	xfft	1536
	xfft	1792
	xfft	2048
	xfft	2560
	xfft	3072
	xfft	3584
	xfft	4096
	xfft	5120
	xfft	6144
	xfft	7168
	xfft	8192

	xfft	32p
	xfft	48p
	xfft	64p
	xfft	96p
	xfft	128p
	xfft	192p
	xfft	256p
	xfft	384p
	xfft	512p
	xfft	768p
	xfft	1024p
	xfft	1536p
	xfft	2048p
	xfft	3072p
	xfft	4096p
	xfft	6144p
	xfft	8192p
_gw_xffts1 ENDP

_TEXT	ENDS
END
